#include <stdio.h>
#include <string.h>

const long MAX_SUBJECTS = 400; //200

template <class T, long SIZE> struct Queue
{
	Queue() {head=tail=0;}
	void In(T value) {data[tail++] = value;}
	T Out() {return data[head++];}
	int IsEmpty() {return head==tail;}

	long head, tail;
	T data[SIZE];
};

//struct Queue
//{
//	Queue() {head=tail=0;}
//	void In(long value) {data[tail++] = value;}
//	long Out() {return data[head++];}
//	int IsEmpty() {return head==tail;}
//
//	long head, tail;
//	long data[MAX_SUBJECTS*2];
//};

int main(void)
{	
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long m[MAX_SUBJECTS][MAX_SUBJECTS];
	long color[MAX_SUBJECTS];
	long wantSubject[MAX_SUBJECTS];
	long iSubject, cSubjects, cPupils, iPupil, nSubject1, nSubject2;

	memset(m, 0, sizeof(m));
	memset(color, 0, sizeof(color));
	memset(wantSubject, 0, sizeof(wantSubject));

	scanf("%ld %ld", &cSubjects, &cPupils);
	for(iPupil = 0; iPupil < cPupils; ++iPupil)
	{
		scanf("%ld %ld", &nSubject1, &nSubject2);
		--nSubject1;
		--nSubject2;
		m[nSubject1][nSubject2] = m[nSubject2][nSubject1] = 1;
		wantSubject[nSubject1] = wantSubject[nSubject2] = 1;
	}
	
	long cWithColorOne = 0;
	int isFirst = 1;
	for(iSubject = 0; iSubject < cSubjects; ++iSubject)
	{
		Queue<long, 2*MAX_SUBJECTS> queue;
		if(color[iSubject] == 0 && wantSubject[iSubject])
		{
			queue.In(iSubject);
			color[iSubject] = 1;
			while(!queue.IsEmpty())
			{
				long curSubject = queue.Out();
				long adjColor = ((color[curSubject] == 1) ? 2 : 1);
				for(long jSubject = 0; jSubject < cSubjects; ++jSubject)
				{
					if(!m[jSubject][curSubject]) continue;
					if(color[jSubject] == color[curSubject])
					{
						puts("no");
						goto exit;
					}
					if(color[jSubject] == 0)
					{
						color[jSubject] = adjColor;
						queue.In(jSubject);
					}
				}
			}
		}
	}
	for(iSubject = 0; iSubject < cSubjects; ++iSubject)
	{
		if(color[iSubject] == 1) ++cWithColorOne;
	}
	puts("yes");
	printf("%ld\n", cWithColorOne);
	for(iSubject = 0; iSubject < cSubjects; ++iSubject)
	{
		if(color[iSubject] == 1)
		{
			if(!isFirst) putchar(' ');
			printf("%ld", iSubject+1);
			isFirst = 0;
		}
	}
	
exit:
#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif
	return 0;
}
